#include <iostream>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    int d[n],p[n];
    for(int i=0;i<n;i++)
    {
        cin>>d[i]>>p[i];
    }
    for(int i=0;i<q;i++)
    {
        int hp;
        cin>>hp;
        int br=0,p_ukupno=0;
        while(hp>0)
        {
            if (br==n)
            {
                br=-1;
                break;
            }
            int d_tren=d[br], p_tren=p[br];
            if (d_tren>p_tren)
            {
                hp-=d_tren+p_ukupno;
                br++;
            }
            else{
                p_ukupno+=p_tren;
                hp-=p_ukupno;
                br++;
            }
        }
        cout<<br<<'\n';
    }
}